/*
*通用代码整理 by heqilin 2016/05/25 update by wangyi 2019-11
*/
let utils ={};
let consts = {
    isLog: true,
    isApp: false,
    isWeb: false
};

// 获取32位随机数
utils.getNum = function(){
	var chars = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'];
	var nums="";
	for(var i=0;i<32;i++){
		var id = parseInt(Math.random()*61);
		nums+=chars[id];
	}
	return nums;
};

// 判断字符串是否为空
utils.isNullOrEmpty = x=> {
    return (x == null || typeof x == "undefined" || x.length==0 || x.toString().trim()=='') ? true : false;
};
utils.isEmptyObject = x=> {
  return (x == null || typeof x == "undefined" || x.length==0 || JSON.stringify(x) == "{}") ? true : false;
};
utils.isInArray = function(value,arr){
  if(utils.isEmptyObject(arr)){
    return false;
  }
    for(var i = 0; i < arr.length; i++){
        if(value === arr[i]){
            return true;
        }
    }
    return false;
};
utils.getDateTimeShort = x=> {
    var datetime=new Date(x.replace(/-/g,'/'));
    var hour=datetime.getHours()>9?datetime.getHours():'0'+datetime.getHours();
    var minutes=datetime.getMinutes()>9?datetime.getMinutes():'0'+datetime.getMinutes();
    return  hour+":"+ minutes;
};
utils.getPercent = function(num, total) {
    /// <summary>
    /// 求百分比
    /// </summary>
    /// <param name="num">当前数</param>
    /// <param name="total">总数</param>
    num = parseFloat(num);
    total = parseFloat(total);
    if (isNaN(num) || isNaN(total)) {
        return "-";
    }
    return total <= 0 ? "0%" : (Math.round(num / total * 10000) / 100.00)+"%";
}
utils.toString = x=> {
  if(x == null || typeof x == "undefined" || x.length==0 || JSON.stringify(x) == "{}"){
    return '';
  }else{
    return x+'';
  }
};
utils.split = x=> {
  x=x+"";
  if(x == null || typeof x == "undefined" || x.length==0 || JSON.stringify(x) == "{}"){
    return '';
  }else{
    return x.split("");
  }
};
utils.showHtml = str=> {
  if(utils.isNullOrEmpty(str)){
    return ''
  }
  return str
  .replace(str ? /&(?!#?\w+;)/g : /&/g, '&amp;')
  .replace(/&lt;/g,"<")
  .replace(/&gt;/g,">")
  .replace(/&quot;/g,"\"")
  .replace(/&#39;/g, "\'");
};

// 截断字符串
utils.cutString = function (str, len, lastDots) {
    if (str.length > len)
        return str.substring(0, len) + (lastDots || "");
    else
        return str;
};
// 获取浏览器url参数,根据key取出参数值
utils.getQueryString = key=> {
    var search = location.search.slice(1); //得到get方式提交的查询字符串
    var arr = search.split("&");
    for (var i = 0; i < arr.length; i++) {
        var ar = arr[i].split("=");
        if (ar[0] == key) {
            if (unescape(ar[1]) == 'undefined') {
                return "";
            } else {
                return unescape(ar[1]);
            }
        }
    }
    return "";
};
// 将json字符串转为x-wwww-from-encoder模式
utils.parseParams = function(data,isEncode) {
    try {
        var tempArr = [];
        for (var i in data) {
            var key = encodeURIComponent(i);
            var value = data[i];
            if(isEncode){
                value = encodeURIComponent(value);
            }
            tempArr.push(key + '=' + value);
        }
        var urlParamsStr = tempArr.join('&');
        return urlParamsStr;
    } catch (err) {
        return '';
    }
};
// 获取当前时间 formatStr可以不传参（yyyy-MM-dd HH:mm:ss）
utils.getNow = formatStr =>{
    if(utils.isNullOrEmpty(formatStr))
        formatStr="yyyy-MM-dd HH:mm:ss";
    return utils.formatDate(formatStr,new Date());
};
// 格式化时间,date1可以不传参数，则取出当前时间
utils.formatDate = function(formatStr,date1){
    var date = new Date();
    if (typeof date1 === 'string') {
        if (date1==null || date1=="" || date1.substring(0, 10) == "1900-01-01")
            return "-";
        date1=date1.replace("-","/");
        date = new Date(date1);
    } else {
        if (date1 != null)
            date = date1;
    }

    /*
    函数：填充0字符
    参数：value-需要填充的字符串, length-总长度
    返回：填充后的字符串
    */

    var zeroize = function (value, length) {
        if (!length) {
            length = 2;
        }
        value = new String(value);
        for (var i = 0, zeros = ''; i < (length - value.length) ; i++) {
            zeros += '0';
        }
        return zeros + value;
    };

    return formatStr.replace(/"[^"]*"|'[^']*'|\b(?:d{1,4}|M{1,4}|yy(?:yy)?|([hHmstT])\1?|[lLZ])\b/g, function ($0) {
        switch ($0) {
            case 'd': return date.getDate();
            case 'dd': return zeroize(date.getDate());
            case 'ddd': return ['Sun', 'Mon', 'Tue', 'Wed', 'Thr', 'Fri', 'Sat'][date.getDay()];
            case 'dddd': return ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'][date.getDay()];
            case 'M': return date.getMonth() + 1;
            case 'MM': return zeroize(date.getMonth() + 1);
            case 'MMM': return ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'][date.getMonth()];
            case 'MMMM': return ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'][date.getMonth()];
            case 'yy': return new String(date.getFullYear()).substr(2);
            case 'yyyy': return date.getFullYear();
            case 'h': return date.getHours() % 12 || 12;
            case 'hh': return zeroize(date.getHours() % 12 || 12);
            case 'H': return date.getHours();
            case 'HH': return zeroize(date.getHours());
            case 'm': return date.getMinutes();
            case 'mm': return zeroize(date.getMinutes());
            case 's': return date.getSeconds();
            case 'ss': return zeroize(date.getSeconds());
            case 'l': return date.getMilliseconds();
            case 'll': return zeroize(date.getMilliseconds());
            case 'tt': return date.getHours() < 12 ? 'am' : 'pm';
            case 'TT': return date.getHours() < 12 ? 'AM' : 'PM';
        }
    });
};
utils.formatSeconds = function (value) {
    var secondTime = parseInt(value);// 秒
    var minuteTime = 0;// 分
    var hourTime = 0;// 小时
    if(secondTime > 60) {//如果秒数大于60，将秒数转换成整数
        //获取分钟，除以60取整数，得到整数分钟
        minuteTime = parseInt(secondTime / 60);
        //获取秒数，秒数取佘，得到整数秒数
        secondTime = parseInt(secondTime % 60);
        //如果分钟大于60，将分钟转换成小时
        if(minuteTime > 60) {
            //获取小时，获取分钟除以60，得到整数小时
            hourTime = parseInt(minuteTime / 60);
            //获取小时后取佘的分，获取分钟除以60取佘的分
            minuteTime = parseInt(minuteTime % 60);
        }
    }
    var result = "" + parseInt(secondTime) + "秒";

    if(minuteTime > 0) {
        result = "" + parseInt(minuteTime) + "分" + result;
    }
    if(hourTime > 0) {
        result = "" + parseInt(hourTime) + "小时" + result;
    }
    return result;
};
// 字符串转Json
utils.toJson = function (str) {
    if (typeof str === 'string') {
        if (str.length <= 0)
            return str;
        else
            return JSON && JSON.parse(str);
    } else {
        return str;
    }
};
// json转字符串
utils.jsonToString = function (json, isRemoveNull) {
    isRemoveNull = isRemoveNull || true;
    if (typeof json === 'object') {
        if (isRemoveNull)
            return JSON && JSON.stringify(json).replace(/\"[^\"]+\":null,/g, '').replace(/,\"[^\"]+\":null/g, '').replace(/\"[^\"]+\":\"\",/g, '').replace(/,\"[^\"]+\":\"\"/g, '');
        else
            return JSON && JSON.stringify(json);
    }
};
// 取出json中的key值
utils.getJsonValue = function (jsonObj, key) {
    for (var item in jsonObj) {
        if (item == key) {
            return jsonObj[item];
        }
    }
    return null;
};
// 取出json中的key值
utils.getJsonKey=function(arrayJsonObj,keyField,valueField,value){
    if(arrayJsonObj==null || arrayJsonObj.length==0)
        return null;
    for(let jsonObj of arrayJsonObj){
        if (jsonObj[valueField] == value) {
            return jsonObj[keyField];
        }
    }
    return null;
};
// 深度copy处理
utils.deepClone = obj=>{
    return JSON.parse(JSON.stringify(obj));
};
// 简单日志打印输出 (字符串，数字，json语句 %s-%d-%j)
utils.log = function(...args){
    if (consts.isLog) {
        console.log(utils.format(...args));
    }
};
// 格式化字符串 (字符串，数字，json语句 %s-%d-%j)
utils.format=function(...args) {
    const formatRegExp = /%[sdj%]/g;
    let i = 1;
    const f = args[0];
    const len = args.length;
    if (typeof f === 'function') {
        return f.apply(null, args.slice(1));
    }
    if (typeof f === 'string') {
        let str = String(f).replace(formatRegExp, (x) => {
            if (x === '%%') {
                return '%';
            }
            if (i >= len) {
                return x;
            }
            switch (x) {
                case '%s':
                    return String(args[i++]);
                case '%d':
                    return Number(args[i++]);
                case '%j':
                    try {
                        return JSON.stringify(args[i++]);
                    } catch (_) {
                        return '[Circular]';
                    }
                    break;
                default:
                    return x;
            }
        });
        for (let arg = args[i]; i < len; arg = args[++i]) {
            str += ` ${arg}`;
        }
        return str;
    }
    return f;
};
// 合并多个对象，第一个参数可以设置为true 则为深度合并/
utils.extend=function() {
    let isDeep =false;
    let assign = function(isDeep,target,source){
        if (source) {
            for (const s in source) {
                if (source.hasOwnProperty(s)) {
                    const value = source[s];
                    if (isDeep && typeof value === 'object' && typeof target[s] === 'object') {
                        assign(isDeep,target[s],value);
                    } else {
                        target[s] = value;
                    }
                }
            }
        }
    };
    let startIdx =1;
    if(typeof arguments[0]==="boolean"){
        startIdx=2;
        isDeep = arguments[0];
    }
    for (var s = startIdx; s < arguments.length; s++) {
        assign(isDeep,arguments[startIdx-1], arguments[s]);
    }
    return arguments[startIdx-1];
};
// 合并多个对象，第一个参数为fn函数
utils.extendEx = function(){
    let isDeep =false;
    let assign = function(isDeep,fnValue,target,source){
        if (source) {
            for (const s in source) {
                if (source.hasOwnProperty(s)) {
                    const value = source[s];
                    if (isDeep && typeof value === 'object' && typeof target[s] === 'object') {
                        assign(isDeep,fnValue,target[s],value);
                    } else {
                        if(typeof fnValue === "function"){
                            target[s] = fnValue.call(null,s,target[s],value);
                        }else{
                            target[s] = value;
                        }
                    }
                }
            }
        }
    };
    let startIdx =2;
    let fnValue =null;
    if(typeof arguments[0]==="boolean"){
        startIdx=3;
        isDeep = arguments[0];
        fnValue = arguments[1];
    }else{
        fnValue = arguments[0];
    }
    for (var s = startIdx; s < arguments.length; s++) {
        assign(isDeep,fnValue,arguments[startIdx-1], arguments[s]);
    }
    return arguments[startIdx-1];
};
//获取周岁(1985-01-01)
utils.getAge = function(strBirthday){
    var returnAge,
        strBirthdayArr=strBirthday.split("-"),
        birthYear = strBirthdayArr[0],
        birthMonth = strBirthdayArr[1],
        birthDay = strBirthdayArr[2],
        d = new Date(),
        nowYear = d.getFullYear(),
        nowMonth = d.getMonth() + 1,
        nowDay = d.getDate();
    if(nowYear == birthYear){
        returnAge = 0;//同年 则为0周岁
    }
    else{
        var ageDiff = nowYear - birthYear ; //年之差
        if(ageDiff > 0){
            if(nowMonth == birthMonth) {
                var dayDiff = nowDay - birthDay;//日之差
                if(dayDiff < 0) {
                    returnAge = ageDiff - 1;
                }else {
                    returnAge = ageDiff;
                }
            }else {
                var monthDiff = nowMonth - birthMonth;//月之差
                if(monthDiff < 0) {
                    returnAge = ageDiff - 1;
                }
                else {
                    returnAge = ageDiff ;
                }
            }
        }else {
            returnAge = -1;//返回-1 表示出生日期输入错误 晚于今天
        }
    }
    return returnAge;//返回周岁年龄
};
// 分页的基本参数->未启用
utils.pagingParam={
    pageIndex:1,
    pageSize:10,
    orderBy:""
};

// 本地存储模块
utils.storageUtil = {
    mySessionStorage: function () {
        return window.sessionStorage;
    },
    myLocalStorage: function () {
        return window.localStorage;
    },
    setLocalStorage: function (key, value) {
        if (arguments.length === 2) {
            var v = value;
            if (typeof v == 'object') {
                v = JSON.stringify(v);
                v = 'obj-' + v;
            } else {
                v = 'str-' + v;
            }
            var ls = utils.storage.myLocalStorage();
            if (ls) {
                ls.setItem(key, v);
            }
        }
    },
    getLocalStorage: function (key) {
        var ls = utils.storage.myLocalStorage();
        if (ls) {
            var v = ls.getItem(key);
            if (!v) { return; }
            if (v.indexOf('obj-') === 0) {
                v = v.slice(4);
                return JSON.parse(v);
            } else if (v.indexOf('str-') === 0) {
                return v.slice(4);
            }
        }
    },
    removeLocalStorage: function (key) {
        var ls = utils.storage.myLocalStorage();
        if (ls && key) {
            ls.removeItem(key);
        }
    },
    clearLocalStorage: function () {
        var ls = utils.storage.myLocalStorage();
        if (ls) {
            ls.clear();
        }
    },
    getLocalStorageFn: function (key, dataFn) {
        var resultStorage = utils.storage.getLocalStorage(key);
        if (utils.stringUtil.isNullOrEmpty(resultStorage)) {
            var result = dataFn();
            utils.done(result, function (datas) {
                if (datas.success == true) {
                    utils.storage.setLocalStorage(key, datas);
                }
            });
            return result;
        } else {
            return resultStorage;
        }
    },

    setSessionStorage: function (key, value) {
        if (arguments.length === 2) {
            var v = value;
            if (typeof v == 'object') {
                v = JSON.stringify(v);
                v = 'obj-' + v;
            } else {
                v = 'str-' + v;
            }
            var ls = utils.storage.mySessionStorage();
            if (ls) {
                ls.setItem(key, v);
            }
        }
    },
    getSessionStorage: function (key) {
        var ls = utils.storage.mySessionStorage();
        if (ls) {
            var v = ls.getItem(key);
            if (!v) { return; }
            if (v.indexOf('obj-') === 0) {
                v = v.slice(4);
                return JSON.parse(v);
            } else if (v.indexOf('str-') === 0) {
                return v.slice(4);
            }
        }
    },
    removeSessionStorage: function (key) {
        var ls = utils.storage.mySessionStorage();
        if (ls && key) {
            ls.removeItem(key);
        }
    },
    clearSessionStorage: function () {
        var ls = utils.storage.mySessionStorage();
        if (ls) {
            ls.clear();
        }
    },
    getSessionStorageFn: function (key, dataFn) {
        var resultStorage = utils.storage.getSessionStorage(key);
        if (utils.stringUtil.isNullOrEmpty(resultStorage)) {
            var result = dataFn();
            utils.done(result, function (datas) {
                if (datas.success == true) {
                    utils.storage.setSessionStorage(key, datas);
                }
            });
            return result;
        } else {
            return resultStorage;
        }
    }
};
// 常用正则模块
utils.regexUtil = {
    //判断手机号码
    isMobile: function (str) {
        return (/^0?1[3|4|5|7|8][0-9]\d{8}$/).test(str);
    },
    // 判断是否是数值
    // @str：字符串
    isNumber: function (str) {
        return !isNaN(str);
    },
    // 判断是否是正小数
    // @str：字符串
    isPlusDecimal: function (str) {
        return (/^(([0-9]|([1-9][0-9]{0,9}))((\.[0-9]{1,2})?))$/).test(str);
    },
    // 判断是否是日期格式
    // @str：字符串
    isDate: function (str) {
        return (/^(?:(?:1[6-9]|[2-9][0-9])[0-9]{2}([-/.]?)(?:(?:0?[1-9]|1[0-2])\1(?:0?[1-9]|1[0-9]|2[0-8])|(?:0?[13-9]|1[0-2])\1(?:29|30)|(?:0?[13578]|1[02])\1(?:31))|(?:(?:1[6-9]|[2-9][0-9])(?:0[48]|[2468][048]|[13579][26])|(?:16|[2468][048]|[3579][26])00)([-/.]?)0?2\2(?:29))(\s+([01][0-9]:|2[0-3]:)?[0-5][0-9]:[0-5][0-9])?$/).text(str);
    },

    isPromise: function (obj) {
        var ispromise = typeof (obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length && Object.prototype.hasOwnProperty.call(obj, 'done');
        return ispromise;
    },

    isJson: function (obj) {
        var isjson = typeof (obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
        return isjson;
    },
    // 判断是否是方法
    // @func：方法句柄
    isFunction: function (func) {
        return (typeof func == "function");
    },
    // 判断是否是json对象
    // @obj：对象
    isObject: function (obj) {
        return (typeof obj == "object" && obj != null && obj != undefined);
    },
    // 判断是否是数组
    // @arr：数组对象
    isArray: function (o) {
        return Object.prototype.toString.call(o) === '[object Array]';
    }
};
// 时间日期模块
utils.dateUtil = {

};
// 常用转换模块
utils.convertUtil = {
    //四舍五入函数
    roundingDigit: function (dight, how) {
        dight = Math.round(dight * Math.pow(10, how)) / Math.pow(10, how);
        return dight;
    },
    //设置手机号码中间部分为*
    setMobileStar: function (mobile, startIndex, starLen) {
        if (utils.isNullOrEmpty(mobile))
            return "-";
        startIndex = startIndex || 4;
        starLen = starLen || 3;
        let temp = "";
        for (let i = 0; i < starLen; i++) {
            temp += "*";
        }
        if (mobile.length >= 11)
            return mobile.substring(0, startIndex) + temp + mobile.substring(starLen + startIndex);
        return mobile;
    }
};

// 兼容旧浏览器平台操作（filter / map / forEach） add 181215
utils.initCompatible = function(){
    if (!Array.prototype.filter) {
        Array.prototype.filter = function (fun) {
            if (this === void 0 || this === null)
                throw new TypeError();

            var t = Object(this);
            var len = t.length >>> 0;
            if (typeof fun !== "function")
                throw new TypeError();

            var res = [];
            var thisArg = arguments.length >= 2 ? arguments[1] : void 0;
            for (var i = 0; i < len; i++) {
                if (i in t) {
                    var val = t[i];
                    if (fun.call(thisArg, val, i, t))
                        res.push(val);
                }
            }
            return res;
        };
    }
    if (!Array.prototype.map) {
        Array.prototype.map = function (callback, thisArg) {
            var T, A, k;
            if (this == null) {
                throw new TypeError(" this is null or not defined");
            }
            var O = Object(this);
            var len = O.length >>> 0;
            if (typeof callback !== "function") {
                throw new TypeError(callback + " is not a function");
            }
            if (thisArg) {
                T = thisArg;
            }
            A = new Array(len);
            k = 0;
            while (k < len) {
                var kValue, mappedValue;
                if (k in O) {
                    kValue = O[k];
                    mappedValue = callback.call(T, kValue, k, O);
                    A[k] = mappedValue;
                }
                k++;
            }
            return A;
        };
    }
    if (!Array.prototype.forEach) {
        Array.prototype.forEach = function (fun /*, thisp*/) {
            var len = this.length;
            if (typeof fun != "function")
                throw new TypeError();
            var thisp = arguments[1];
            for (var i = 0; i < len; i++) {
                if (i in this)
                    fun.call(thisp, this[i], i, this);
            }
        };
    }
};

utils.uploadUtil = {
    baiduWebUploader1: function (id, successFn) {

        var uploader = WebUploader.create({
            swf: './webuploader/Uploader.swf',
            // 自动上传。
            auto: true,
            // 文件接收服务端。
            server: "/api/my/system/upload/baidu",
            //fileNumLimit: 1,
            fileSizeLimit: 10 * 1024 * 1024,    // 10 M
            fileSingleSizeLimit: 10 * 1024 * 1024,    // 10 M
            // 选择文件的按钮。可选。
            // 内部根据当前运行是创建，可能是input元素，也可能是flash.
            pick: '#' + id,
            // 只允许选择文件，可选。
            accept: {
                title: 'Files',
                extensions: 'gif,jpg,jpeg,bmp,png,pdf,doc,docx,txt,xls,xlsx,ppt,pptx,zip,mp3,mp4,text,csv',
                mimeTypes: 'image/*,text/*'
                //word
            + ',application/msword,application/vnd.openxmlformats-officedocument.wordprocessingml.document'
                //excel
            + ',application/vnd.ms-excel,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
                //ppt
            + ',application/vnd.ms-powerpoint,application/vnd.openxmlformats-officedocument.presentationml.presentation'
            + ',application/pdf'
            + ',application/zip'
            + ',application/csv'
            }
        });

        // 文件上传成功，给item添加成功class, 用样式标记上传成功。
        uploader.on('uploadSuccess', function (file, response) {
            $('#' + file.id).addClass('upload-state-done');
            if (successFn) {
                successFn(response);
            }
            console.log('response:', response);
        });

    }
};

utils.artT = function (tplId, renderId, datas, callbackFn) {
    datas = utils.toJson(datas);
    var result = template(tplId, { "data": datas });
    utils.log(result);
    if (callbackFn) {
        callbackFn(renderId, result);
    } else {
       // $("#" + renderId).html(result);
       var el = $api.byId(renderId);
        $api.html(el,result);
    }
};

utils.doT = function (tplId, renderId, datas) {
    datas = utils.toJson(datas);
    var result = doT.template($api.text($api.byId(tplId)))(datas);
    utils.log(result);
    var el = $api.byId(renderId);
    $api.html(el,result);
};


// 写入全局
window.utils = utils;
window.consts = consts;

//全局返回页面方法 wy
window.goBack=function(){
  api.historyBack({}, function(ret, err) {
      if (!ret.status) {
          api.closeWin();
      }
  });
}
